.386
.MODEL FLAT

.CODE
_run:

include         stdparas.inc                            ; PA1-PA4
include         abpstruc.inc                            ; asmBmpPara-structure

; **************************************************************************************

asmBmpPara      EQU     <PA1>

; **************************************************************************************

Shade           PROC    NEAR

init:           mac     SAVE
                mov     ebx,asmBmpPara                  ; initialize loop
                mov     esi,srcBits
                mov     edi,tgtBits
                mov     ecx,srcWidth
                imul    ecx,srcHeight
                mov     edx,PA2
                
bmp_loop:       lodsd                                   ; change pixels
                rol     eax,16
                mul     dl
                rol     eax,8
                mul     dl
                rol     eax,8
                mul     dl
                shr     eax,8
                stosd
                dec     ecx
                jnz     bmp_loop

                stc                
finish:         mac     REST

Shade           ENDP

END _run
