Attribute VB_Name = "asm_Shade"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

' asmShade
'
' CALL          asmShade(ptr:lpAsmBmpPara, [fct:factor])
'
' IN:           lng:ptr Points to asmBmpPara-structure
'               lng:fct 0 to 100         (default = 10)
'
' OUT:          bol     success
'
Function asmShade(lpAsmBmpPara As Long, Optional fct As Long = 10) As Boolean
    
    Static asm(14) As Long
    
    If asm(0) = 0 Then
        asm(0) = &HEC8B5590
        asm(1) = &H8B575653
        asm(2) = &H738B085D
        asm(3) = &H2C7B8B14
        asm(4) = &HF044B8B
        asm(5) = &H8B084BAF
        asm(6) = &HC1AD0C55
        asm(7) = &HE2F610C0
        asm(8) = &HF608C0C1
        asm(9) = &H8C0C1E2
        asm(10) = &HE8C1E2F6
        asm(11) = &H7549AB08
        asm(12) = &HC01BF9E9
        asm(13) = &H5D5B5E5F
        asm(14) = &H10C2
    End If
    
    ' ************************************************************
    
    
    asmShade = CallWindowProc(asm(0), lpAsmBmpPara, (100 - fct) * 2.56, 0, 0)
End Function

' basShade
'
' AUFRUF:       basShade(src, tgt, [fct:Faktor])
'
' EIN:          bar:src Herkunftsdaten (ByteArray)
'               bar:tgt Zieldaten      (ByteArray)
'               lng:fct Faktor 0-100   (Vorgabe 10)
'
' AUS:          log     Erfolg
'
Function basShade(src() As Byte, tgt() As Byte, Optional fct As Long = 10) As Boolean
    
    Dim S1 As Single
    Dim X1 As Long
    Dim Y1 As Long
    
    If fct = 0 Then
        CopyMemory tgt(1, 1), src(1, 1), UBound(src, 1) * UBound(src, 2)
        
    ElseIf fct < 0 Or fct > 100 Then
        MsgBox "invalid parameter fct" & fct
        
    Else
        S1 = (100 - fct) / 100
        
        For Y1 = 1 To UBound(src, 2)
            For X1 = 1 To UBound(src, 1) Step 4
                tgt(X1 + 0, Y1) = src(X1 + 0, Y1) * S1
                tgt(X1 + 1, Y1) = src(X1 + 1, Y1) * S1
                tgt(X1 + 2, Y1) = src(X1 + 2, Y1) * S1
            Next
        Next
        
        basShade = True
    End If
End Function
